;;;; remote-mailbox-packet.scm
;;;; Kon Lovett, Sep '17

(module remote-mailbox-packet

(;export
  ;;
  make-remote-mailbox-packet
  remote-mailbox-packet?
  remote-mailbox-packet-key
  remote-mailbox-packet-value )

(import scheme chicken)

;;; Remote Mailbox Packet

(define +remote-mailbox-tag+ 'rmbtag)

(define (make-remote-mailbox-packet key val)
  (vector +remote-mailbox-tag+ key val) )

(define (remote-mailbox-packet? obj)
	(and
	  (vector? obj)
    (fx= 3 (vector-length obj))
    (eq? +remote-mailbox-tag+ (vector-ref obj 0))) )

(define (remote-mailbox-packet-key rmp)
  (vector-ref rmp 1) )

(define (remote-mailbox-packet-value rmp)
  (vector-ref rmp 2) )

) ;module remote-mailbox-packet
